module RegisterFile(
    Clock,
    Enable,

    ReadAddress0,
    ReadData0,
    ReadAddress1,
    ReadData1,

    WriteAddress,
    WriteEnable,
    WriteData
); // synthesis attribute ram_style of RegisterFile is distributed

input                   Clock;
input                   Enable;

input  [4:0]            ReadAddress0;
output [31:0]           ReadData0;
input  [4:0]            ReadAddress1;
output [31:0]           ReadData1;

input  [4:0]            WriteAddress;
input                   WriteEnable;
input  [31:0]           WriteData;

reg    [31:0]           state[31:1];

wire   [31:0]           fwded_read0;
wire   [31:0]           fwded_read1;

always@(posedge Clock) begin
    if(WriteEnable == 1'b1 && WriteAddress != 5'b00000 && Enable == 1'b1) begin
        state[WriteAddress] <= WriteData;
    end
end

assign ReadData0 = ReadAddress0 == 5'b00000 ? 32'h0000_0000 : fwded_read0;
assign ReadData1 = ReadAddress1 == 5'b00000 ? 32'h0000_0000 : fwded_read1;

assign fwded_read0 = (ReadAddress0 == WriteAddress && WriteEnable == 1'b1) ? WriteData : state[ReadAddress0];
assign fwded_read1 = (ReadAddress1 == WriteAddress && WriteEnable == 1'b1) ? WriteData : state[ReadAddress1];

endmodule
